diff -urN microwindows-0.91/src/nanox/srvfunc.c microwindows-0.91.g100/src/nanox/srvfunc.c
--- microwindows-0.91/src/nanox/srvfunc.c	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/srvfunc.c	2007-06-09 21:37:03.000000000 +0200
@@ -283,6 +283,9 @@
 			if (psd->flags & PSF_ADDRMALLOC)
 				free(psd->addr);
 
+/*REM*/			if(pp->alpha)
+/*REM*/			  free(pp->alpha);
+
 			/* deallocate mem gc*/
 			psd->FreeMemGC(psd);
 
@@ -504,7 +507,7 @@
 #if 1
 	/* perform screen blit if topmost and mapped - no flicker!*/
 	if (wp->mapped && wp == wp->parent->children
-		&& wp->parent->id == GR_ROOT_WINDOW_ID
+	    && wp->parent->id == GR_ROOT_WINDOW_ID
 
 		/* temp don't blit in portrait mode, still buggy*/
 		/* *&& !(wp->psd->portrait & (MWPORTRAIT_LEFT|MWPORTRAIT_RIGHT))***/
@@ -590,11 +593,12 @@
 		return;
 	}
 #endif
+
 	/*
 	 * This method will redraw the window entirely,
 	 * resulting in considerable flicker.
 	 */
-	GsWpUnrealizeWindow(wp, GR_TRUE);
+	GsWpUnrealizeWindow(wp, GR_TRUE, /*REM Do clear*/GR_FALSE);
 	OffsetWindow(wp, offx, offy);
 	GsWpRealizeWindow(wp, GR_FALSE);
 	DeliverUpdateMoveEventAndChildren(wp);
@@ -637,6 +641,21 @@
 	if (!wp->realized || !wp->output) {
 		wp->width = width;
 		wp->height = height;
+/*REM BEGIN:*/
+#if defined(TRANS_COLOR)
+		/* Change space for alpha values */
+		if(wp->alpha) {
+		  free(wp->alpha);
+		  wp->alpha = calloc(width*height, 1);
+		  
+		  if (wp->alpha)
+		    memset(wp->alpha,(unsigned char) MWA(wp->background),width*height);
+		  else
+		    GsError(GR_ERROR_MALLOC_FAILED, wp->id);
+		}
+#endif
+/*REM END*/
+
 		SERVER_UNLOCK();
 		return;
 	}
@@ -645,9 +664,25 @@
 	 * This should be optimized to not require redrawing of the window
 	 * when possible.
 	 */
-	GsWpUnrealizeWindow(wp, GR_TRUE);
+	GsWpUnrealizeWindow(wp, GR_TRUE, /*REM DoClear*/GR_FALSE);
 	wp->width = width;
 	wp->height = height;
+
+/*REM BEGIN:*/
+#if defined(TRANS_COLOR)
+	  /* Change space for alpha values */
+	  if(wp->alpha) {
+	    free(wp->alpha);
+	    wp->alpha = calloc(width*height, 1);
+
+	    if (wp->alpha)
+	      memset(wp->alpha,(unsigned char) MWA(wp->background),width*height);
+	    else
+	      GsError(GR_ERROR_MALLOC_FAILED, wp->id);
+	  }
+#endif
+/*REM END*/
+
 	/* send size update before expose event*/
 	GsDeliverUpdateEvent(wp, GR_UPDATE_SIZE, wp->x, wp->y, width, height);
 	GsWpRealizeWindow(wp, GR_FALSE);
@@ -680,7 +715,6 @@
 		return;
 	}
 
-/*printf("grreparent: pid %d wid %d (oldpid %d) realized %d,%d\n", pwid, wid, wp->parent->id, pwp->realized, wp->realized);*/
 	x += pwp->x;
 	y += pwp->y;
 	offx = x - wp->x;
@@ -690,7 +724,7 @@
 	 * Unrealize window and all children.  No effect if
 	 * this window isn't already realized.
 	 */
-	GsWpUnrealizeWindow(wp, GR_TRUE);
+	GsWpUnrealizeWindow(wp, GR_TRUE,/*REM Do Clear*/GR_FALSE);
 
 	/* link window into new parent chain*/
 	for(mysibptr = &(wp->parent->children); *mysibptr != wp; 
@@ -1702,7 +1736,17 @@
 
 	pwp->children = wp;
 	listwp = wp;
-
+/*REM BEGIN:*/
+#if defined(TRANS_COLOR)
+	wp->alpha = calloc(width*height, 1);
+	if (wp->alpha)
+	  memset(wp->alpha,(unsigned char) MWA(background),width*height);
+	else
+	  GsError(GR_ERROR_MALLOC_FAILED, wp->id);
+#else
+	wp->alpha = NULL;
+#endif
+/*REM END*/
 	return wp;
 }
 
@@ -1848,12 +1892,105 @@
         listpp = pp;
 	
 	id = pp->id;
-	
+
+/*REM BEGIN:*/
+#if defined(TRANS_COLOR)
+	pp->alpha = calloc(width*height, 1);
+	if (!pp->alpha)
+	  GsError(GR_ERROR_MALLOC_FAILED, pp->id);
+	//else
+	//  memset(pp->alpha,0xff,width*height);
+#else
+	pp->alpha = NULL;
+#endif
+/*REM END*/
+
 	SERVER_UNLOCK();
 	
 	return id;
 }
 
+/*REM BEGIN:*/
+/*
+ * Allocate a pixmap, can be used with any drawing functions
+ * for offscreen drawing
+ */
+GR_WINDOW_ID
+GrResizePixmap(GR_WINDOW_ID wid,GR_SIZE width, GR_SIZE height, void * pixels)
+{
+	GR_PIXMAP	*pp;
+	PSD		psd;
+        int 		size, linelen, bpp, planes;
+	GR_WINDOW_ID    id;
+  
+	if (width <= 0 || height <= 0) {
+		/* no error for now, server will desynchronize w/app*/
+		/*GsError(GR_ERROR_BAD_WINDOW_SIZE, 0);*/
+		return 0;
+	}
+
+	SERVER_LOCK();
+
+
+	pp = GsFindPixmap(wid);
+	if (pp) {
+	  psd = pp->psd;
+
+
+	  /* Allocate space for pixel values */
+	  GdCalcMemGCAlloc(psd, width, height, 0, 0, &size, &linelen);
+	  if (!pixels) {
+	    pixels = calloc(size, 1);
+	  }
+
+	  /* do nothing if we got no space*/
+	  if (!pixels) {
+	    GsError(GR_ERROR_MALLOC_FAILED, 0);
+	    SERVER_UNLOCK();
+	    return 0;
+	  }
+  
+	  /* deallocate pixmap memory*/
+	  if ((psd->flags & PSF_ADDRMALLOC)&&(psd->addr))
+	    free(psd->addr);
+
+	  bpp = psd->bpp;
+
+
+#if defined(TRANS_COLOR)
+	  /* Change space for alpha values */
+	  if(pp->alpha) {
+	    free(pp->alpha);
+	    pp->alpha = calloc(width*height, 1);
+
+	    if (pp->alpha)
+	      memset(pp->alpha,0xff,width*height);
+	    else
+	      GsError(GR_ERROR_MALLOC_FAILED, pp->id);
+	  }
+#endif
+
+	  /* change values*/
+	  pp->width = width;
+	  pp->height = height;
+
+	  planes = psd->planes;
+	  psd->MapMemGC(psd, width, height, planes, bpp, linelen, size,
+			pixels/*,alpha for future use*/);
+
+          psd->flags |= PSF_ADDRMALLOC;
+	  id = pp->id;
+	
+	  SERVER_UNLOCK();
+	  
+	  return id;
+	}
+	else
+	  return 0;
+}
+/*REM END*/
+
+
 /*
  * Map the window to make it (and possibly its children) visible on the screen.
  */
@@ -1893,7 +2030,7 @@
 		return;
 	}
 
-	GsWpUnrealizeWindow(wp, GR_FALSE);
+	GsWpUnrealizeWindow(wp, GR_FALSE, /*REM Do Clear*/GR_FALSE);
 
 	wp->mapped = GR_FALSE;
 
@@ -1918,7 +2055,16 @@
 			width = wp->width;
 		if (height == 0)
 			height = wp->height;
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/	        GR_SIZE bs = wp->bordersize;
+/*REM*/		if(MWA(wp->background)==0)
+//*REM*/		  GsExposeArea(rootwp, wp->x - bs, wp->y - bs, wp->width + bs * 2, wp->height + bs * 2, NULL);
+		/*REM*/		  GsWpClearWindowUpAndDown(wp, x, y, width, height, exposeflag);
+/*REM*/		else
+/*REM*/		  GsWpClearWindow(wp, x, y, width, height, exposeflag);
+/*REM*/#else
 		GsWpClearWindow(wp, x, y, width, height, exposeflag);
+/*REM*/#endif
 	}
 
 	SERVER_UNLOCK();
@@ -2533,12 +2679,17 @@
 	GR_DRAWABLE	*dp;
 
 	SERVER_LOCK();
+	//*REM*/MWRECT RelAreaToDraw={x1>x2?x2:x1,/*left*/
+        //			     y1>y2?y2:y1,/*top*/
+        //				     x2>x1?x2+1:x1+1,/*right*/
+        //				     y2>y1?y2+1:y1+1 /*bottom*/
+        //	};
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp/*REM*/,/*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdLine(dp->psd, dp->x + x1, dp->y + y1,
-				dp->x + x2, dp->y + y2, TRUE);
+			       dp->x + x2, dp->y + y2, TRUE);
 			break;
 	}
 
@@ -2559,7 +2710,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
       	        case GR_DRAW_TYPE_PIXMAP:
 			GdRect(dp->psd, dp->x + x, dp->y + y, width, height);
@@ -2581,7 +2734,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp, /*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdFillRect(dp->psd, dp->x + x, dp->y + y, width,height);
@@ -2603,7 +2758,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdEllipse(dp->psd, dp->x + x, dp->y + y, rx, ry, FALSE);
@@ -2625,7 +2782,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdEllipse(dp->psd, dp->x + x, dp->y + y, rx, ry, TRUE);
@@ -2648,7 +2807,7 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdArc(dp->psd, dp->x + x, dp->y + y, rx, ry, ax, ay,
@@ -2672,7 +2831,7 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdArcAngle(dp->psd, dp->x + x, dp->y + y, rx, ry,
@@ -2700,8 +2859,10 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
-		case GR_DRAW_TYPE_WINDOW:
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
+	        case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdBitmap(dp->psd, dp->x + x, dp->y + y, width, height,
 				imagebits);
@@ -2720,7 +2881,7 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdDrawImage(dp->psd, dp->x + x, dp->y + y, pimage);
@@ -2740,7 +2901,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
  	        case GR_DRAW_TYPE_PIXMAP:
 			GdDrawImageFromFile(dp->psd, dp->x + x, dp->y + y,
@@ -2794,7 +2957,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 	case GR_DRAW_TYPE_WINDOW:
 	case GR_DRAW_TYPE_PIXMAP:
 		GdDrawImageFromBuffer(dp->psd, dp->x + x, dp->y + y,
@@ -2847,7 +3012,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
  	        case GR_DRAW_TYPE_PIXMAP:
 			GdDrawImageToFit(dp->psd, dp->x + x, dp->y + y,
@@ -2915,7 +3082,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdArea(dp->psd, dp->x + x, dp->y + y, width, height,
@@ -2939,16 +3108,22 @@
 
 	GR_DRAWABLE	*dp;
         GR_WINDOW	*swp;
+#if defined(TRANS_COLOR)
+/*REM*/ GR_WINDOW	*dwp=NULL;
+/*REM*/ GR_PIXMAP	*dpp=NULL;
+#endif
         GR_PIXMAP	*spp = NULL;
         GR_DRAW_TYPE	type;
         PSD 		srcpsd;
 
 	SERVER_LOCK();
+	//*REM*/This may not work since GsPrepareDraw wont
+	//*REM*/call GdSetClipwindow again if clipwp didnt change
+	//*REM*/MWRECT RelAreaToDraw={x,y,x+width,y+height};
    
         srcpsd = NULL;
-
         swp = GsFindWindow(srcid);
-        type = GsPrepareDrawing(id, gc, &dp);
+        type = GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL);
 	if (type == GR_DRAW_TYPE_NONE) {
 		SERVER_UNLOCK();
 		return;
@@ -3022,9 +3197,62 @@
 		}
 	}
 
+#if defined(TRANS_COLOR)
+/*REM*/	if(swp && (op == MWROP_SRCTRANSCOPY))  GdSetAlphaChannel(swp->alpha,swp->x,swp->y,swp->width,swp->height);
+/*REM*/	if(spp && (op == MWROP_SRCTRANSCOPY))  GdSetAlphaChannel(spp->alpha,spp->x,spp->y,spp->width,spp->height);
+#endif
+
 	/* perform blit*/
 	GdCheckCursor(srcpsd, srcx, srcy, srcx+width, srcy+height); /* FIXME*/
 	GdBlit(dp->psd, dp->x+x, dp->y+y, width, height, srcpsd, srcx, srcy,op);
+#if defined(TRANS_COLOR)
+/*REM BEGIN:*/
+	//FIXME: GsFindWindow is called twice (already in PrepareDraw)
+	//FIXME: Only blit if dwp has a transparent bg
+        dwp = GsFindWindow(id);
+	if(!dwp) dpp=GsFindPixmap(id);
+	GR_SIZE dheight;
+	GR_SIZE dwidth;
+	unsigned char * salpha=NULL;
+	unsigned char * dalpha=NULL;
+	//dst is a window
+	if(dwp)
+	  {
+	    dalpha=dwp->alpha;
+	    dwidth=dwp->width;
+	    dheight=dwp->height;
+	    //src is a window
+	    if(swp)
+	      salpha=swp->alpha;
+
+	    //src is a pixmap
+	    else if (spp)
+	      salpha=spp->alpha;
+	  }
+	//dst is a pixmap
+	else if(dpp)
+	  {
+	    dalpha=dpp->alpha;
+	    dwidth=dpp->width;
+	    dheight=dpp->height;
+	    //src is a window
+	    if(swp)
+	      salpha=swp->alpha;
+
+	    //src is a pixmap
+	    else if (spp)
+	      salpha=spp->alpha;
+	  }
+	if(dalpha && salpha)
+	  {
+	    GdAlphaBlit(dalpha, x, y, dwidth, dheight, /*copy to x,y and handle over height/width*/
+			salpha, x, y, width, height); /*copy from x,y and copy rectangle height/width*/
+	  }
+
+/*REM END:*/
+#endif
+
+
 	GdFixCursor(srcpsd); /* FIXME*/
 
 	SERVER_UNLOCK();
@@ -3092,7 +3320,9 @@
 
 	SERVER_LOCK();
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	/*REM*/MWRECT RelAreaToDraw={x,y,x+1,y+1};
+
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdPoint(dp->psd, dp->x + x, dp->y + y);
@@ -3116,7 +3346,7 @@
 
 	SERVER_LOCK();
    
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 	                psd = dp->psd;
@@ -3149,7 +3379,7 @@
 
 	SERVER_LOCK();
    
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 	                psd = dp->psd;
@@ -3202,7 +3432,7 @@
 
 	SERVER_LOCK();
    
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 	                psd = dp->psd;
@@ -3256,7 +3486,7 @@
 	if((flags&(MWTF_TOP|MWTF_BASELINE|MWTF_BOTTOM)) == 0)
 		flags |= MWTF_BASELINE;
 
-	switch (GsPrepareDrawing(id, gc, &dp)) {
+	switch (GsPrepareDrawing(id, gc, &dp,/*REM*/NULL)) {
 		case GR_DRAW_TYPE_WINDOW:
 	        case GR_DRAW_TYPE_PIXMAP:
 			GdText(dp->psd, dp->x + x, dp->y + y, str, count,flags);
@@ -3361,7 +3591,24 @@
 
 	/* Set window properties*/
 	if (props->flags & GR_WM_FLAGS_PROPS)
-		wp->props = props->props;
+/*REM BEGIN*/
+#if defined(TRANS_COLOR)
+	  {
+	    wp->props = props->props;
+	    /*
+	     * If GR_WM_PROPS_APPWINDOW and GR_WM_PROPS_NOBACKGROUND is set, we assume a container window.
+	     * Further we assume (accordint to nanowms code) that the border will be redrawn soon.
+	     * So we clear the alpha map in order to provide GrSetClipWindowRec a valid alpha map for
+	     * container with transparent childs.
+	     */
+
+	    if(wp->alpha && (wp->props & (GR_WM_PROPS_APPWINDOW|GR_WM_PROPS_NOBACKGROUND)))
+	      memset(wp->alpha,0,(wp->width)*(wp->height));
+	  }
+#else
+	wp->props = props->props;
+#endif
+/*REM END*/
 
 	/* Set window title*/
 	if (props->flags & GR_WM_FLAGS_TITLE) {
@@ -3401,7 +3648,7 @@
 	if (props->flags & GR_WM_FLAGS_BORDERSIZE) {
 		if (wp->bordersize != props->bordersize) {
 			/* FIXME: check if this works if not already realized*/
-			GsWpUnrealizeWindow(wp, GR_TRUE);
+		  GsWpUnrealizeWindow(wp, GR_TRUE,/*REM Do Clear*/GR_FALSE);
 			wp->bordersize = props->bordersize;
 			GsWpRealizeWindow(wp, GR_TRUE);
 		}
@@ -3703,6 +3950,12 @@
 	wp->bgpixmap = pp;
 	wp->bgpixmapflags = flags;
 
+//*REM*/#if defined(TRANS_COLOR)
+   //	if((wp->width==pp->width)&&(wp->height==pp->height)&&wp->alpha&&pp->alpha)
+   //	  memcpy(wp->alpha,pp->alpha,wp->width * wp->height);
+//*REM*/#endif
+
+
 	SERVER_UNLOCK();
 }
 
@@ -3741,10 +3994,11 @@
 	PSD srcpsd;
 
 	SERVER_LOCK();
+	/*REM*/MWRECT RelAreaToDraw={dx1,dy1,dx2+1,dy2+1};
 
 	srcpsd = NULL;
 
-	type = GsPrepareDrawing(dstid, gc, &dp);
+	type = GsPrepareDrawing(dstid, gc, &dp,/*REM*//*&RelAreaToDraw*/NULL);
 	if (type == GR_DRAW_TYPE_NONE) {
 		SERVER_UNLOCK();
 		return;
diff -urN microwindows-0.91/src/nanox/srvmain.c microwindows-0.91.g100/src/nanox/srvmain.c
--- microwindows-0.91/src/nanox/srvmain.c	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/srvmain.c	2006-12-17 13:14:43.000000000 +0100
@@ -972,6 +972,12 @@
 	wp->title = NULL;
 	wp->clipregion = NULL;
 
+/*REM BEGIN:*/
+	//rootwindow does not need any alpha map
+        //since ther cannot be any other objects below
+       	wp->alpha = NULL;
+/*REM END*/
+	
         listpp = NULL;
 	listwp = wp;
 	rootwp = wp;
diff -urN microwindows-0.91/src/nanox/srvnet.c microwindows-0.91.g100/src/nanox/srvnet.c
--- microwindows-0.91/src/nanox/srvnet.c	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/srvnet.c	2006-10-12 18:23:49.000000000 +0200
@@ -1596,6 +1596,21 @@
 #endif /*HAVE_FREETYPE_2_SUPPORT*/
 }
 
+/*REM BEGIN:*/
+static void
+GrResizePixmapWrapper(void *r)
+{
+	nxResizePixmapReq *req = r;
+	GR_WINDOW_ID	wid;
+
+	wid = 	GrResizePixmap(req->windowid, req->width, req->height,0);
+
+	GsWriteType(current_fd,GrNumResizePixmap);
+	GsWrite(current_fd, &wid, sizeof(wid));
+
+}
+/*REM END*/
+
 
 void GrShmCmdsFlushWrapper(void *r);
 
@@ -1731,6 +1746,7 @@
 	/* 122 */ {GrSetTransformWrapper, "GrSetTransform" },
 	/* 123 */ {GrCreateFontFromBufferWrapper, "GrCreateFontFromBuffer"},
 	/* 124 */ {GrCopyFontWrapper, "GrCopyFont"},
+/*REM*/	/* 125 */ {GrResizePixmapWrapper, "GrResizePixmap"},
 };
 
 void
